diff --git a/dirsrvtests/tests/suites/acl/acl_test.py b/dirsrvtests/tests/suites/acl/acl_test.py
index f42a584..89ca14b 100644
--- a/dirsrvtests/tests/suites/acl/acl_test.py
+++ b/dirsrvtests/tests/suites/acl/acl_test.py
@@ -1,5 +1,5 @@
 # --- BEGIN COPYRIGHT BLOCK ---
-# Copyright (C) 2015 Red Hat, Inc.
+# Copyright (C) 2016 Red Hat, Inc.
 # All rights reserved.
 #
 # License: GPL (version 3 or any later version).
@@ -23,33 +23,27 @@ from ldap.controls.simple import GetEffectiveRightsControl
 logging.getLogger(__name__).setLevel(logging.DEBUG)
 log = logging.getLogger(__name__)
 
-#
-# important part. We can deploy Master1 and Master2 on different versions
-#
-installation1_prefix = None
-installation2_prefix = None
-
 TEST_REPL_DN = "cn=test_repl, %s" % SUFFIX
 
-STAGING_CN     = "staged user"
-PRODUCTION_CN  = "accounts"
-EXCEPT_CN      = "excepts"
+STAGING_CN = "staged user"
+PRODUCTION_CN = "accounts"
+EXCEPT_CN = "excepts"
 
-STAGING_DN    = "cn=%s,%s" % (STAGING_CN, SUFFIX)
+STAGING_DN = "cn=%s,%s" % (STAGING_CN, SUFFIX)
 PRODUCTION_DN = "cn=%s,%s" % (PRODUCTION_CN, SUFFIX)
 PROD_EXCEPT_DN = "cn=%s,%s" % (EXCEPT_CN, PRODUCTION_DN)
 
-STAGING_PATTERN    = "cn=%s*,%s" % (STAGING_CN[:2],    SUFFIX)
+STAGING_PATTERN = "cn=%s*,%s" % (STAGING_CN[:2], SUFFIX)
 PRODUCTION_PATTERN = "cn=%s*,%s" % (PRODUCTION_CN[:2], SUFFIX)
-BAD_STAGING_PATTERN    = "cn=bad*,%s" % (SUFFIX)
+BAD_STAGING_PATTERN = "cn=bad*,%s" % (SUFFIX)
 BAD_PRODUCTION_PATTERN = "cn=bad*,%s" % (SUFFIX)
 
-BIND_CN        = "bind_entry"
-BIND_DN        = "cn=%s,%s" % (BIND_CN, SUFFIX)
-BIND_PW        = "password"
+BIND_CN = "bind_entry"
+BIND_DN = "cn=%s,%s" % (BIND_CN, SUFFIX)
+BIND_PW = "password"
 
-NEW_ACCOUNT    = "new_account"
-MAX_ACCOUNTS   = 20
+NEW_ACCOUNT = "new_account"
+MAX_ACCOUNTS = 20
 
 CONFIG_MODDN_ACI_ATTR = "nsslapd-moddn-aci"
 
@@ -61,127 +55,7 @@ SRC_ENTRY_DN = "cn=%s,%s" % (SRC_ENTRY_CN, SUFFIX)
 DST_ENTRY_DN = "cn=%s,%s" % (DST_ENTRY_CN, SUFFIX)
 
 
-class TopologyMaster1Master2(object):
-    def __init__(self, master1, master2):
-        master1.open()
-        self.master1 = master1
-
-        master2.open()
-        self.master2 = master2
-
-
-@pytest.fixture(scope="module")
-def topology(request):
-    """This fixture is used to create a replicated topology for the 'module'.
-    The replicated topology is MASTER1 <-> Master2.
-    """
-
-    global installation1_prefix
-    global installation2_prefix
-
-    # allocate master1 on a given deployement
-    master1 = DirSrv(verbose=False)
-    if installation1_prefix:
-        args_instance[SER_DEPLOYED_DIR] = installation1_prefix
-
-    # Args for the master1 instance
-    args_instance[SER_HOST] = HOST_MASTER_1
-    args_instance[SER_PORT] = PORT_MASTER_1
-    args_instance[SER_SERVERID_PROP] = SERVERID_MASTER_1
-    args_master = args_instance.copy()
-    master1.allocate(args_master)
-
-    # allocate master1 on a given deployement
-    master2 = DirSrv(verbose=False)
-    if installation2_prefix:
-        args_instance[SER_DEPLOYED_DIR] = installation2_prefix
-
-    # Args for the consumer instance
-    args_instance[SER_HOST] = HOST_MASTER_2
-    args_instance[SER_PORT] = PORT_MASTER_2
-    args_instance[SER_SERVERID_PROP] = SERVERID_MASTER_2
-    args_master = args_instance.copy()
-    master2.allocate(args_master)
-
-    # Get the status of the instance and restart it if it exists
-    instance_master1 = master1.exists()
-    instance_master2 = master2.exists()
-
-    # Remove all the instances
-    if instance_master1:
-        master1.delete()
-    if instance_master2:
-        master2.delete()
-
-    # Create the instances
-    master1.create()
-    master1.open()
-    master2.create()
-    master2.open()
-
-    #
-    # Now prepare the Master-Consumer topology
-    #
-    # First Enable replication
-    master1.replica.enableReplication(suffix=SUFFIX,
-                                      role=REPLICAROLE_MASTER,
-                                      replicaId=REPLICAID_MASTER_1)
-    master2.replica.enableReplication(suffix=SUFFIX,
-                                      role=REPLICAROLE_MASTER,
-                                      replicaId=REPLICAID_MASTER_2)
-
-    # Initialize the supplier->consumer
-
-    properties = {RA_NAME:      r'meTo_$host:$port',
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    repl_agreement = master1.agreement.create(suffix=SUFFIX,
-                                              host=master2.host,
-                                              port=master2.port,
-                                              properties=properties)
-
-    if not repl_agreement:
-        log.fatal("Fail to create a replica agreement")
-        sys.exit(1)
-
-    log.debug("%s created" % repl_agreement)
-
-    properties = {RA_NAME:      r'meTo_$host:$port',
-                  RA_BINDDN:    defaultProperties[REPLICATION_BIND_DN],
-                  RA_BINDPW:    defaultProperties[REPLICATION_BIND_PW],
-                  RA_METHOD:    defaultProperties[REPLICATION_BIND_METHOD],
-                  RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
-    master2.agreement.create(suffix=SUFFIX,
-                             host=master1.host,
-                             port=master1.port,
-                             properties=properties)
-
-    master1.agreement.init(SUFFIX, HOST_MASTER_2, PORT_MASTER_2)
-    master1.waitForReplInit(repl_agreement)
-
-    # Check replication is working fine
-    if master1.testReplication(DEFAULT_SUFFIX, master2):
-        log.info('Replication is working.')
-    else:
-        log.fatal('Replication is not working.')
-        assert False
-
-    def fin():
-        master1.delete()
-        master2.delete()
-    request.addfinalizer(fin)
-
-    # clear the tmp directory
-    master1.clearTmpDir(__file__)
-
-    # Here we have two instances master and consumer
-    # with replication working.
-    return TopologyMaster1Master2(master1, master2)
-
-
-def add_attr(topology, attr_name):
+def add_attr(topology_m2, attr_name):
     """Adds attribute to the schema"""
 
     ATTR_VALUE = """(NAME '%s' \
@@ -190,7 +64,7 @@ def add_attr(topology, attr_name):
     mod = [(ldap.MOD_ADD, 'attributeTypes', ATTR_VALUE)]
 
     try:
-        topology.master1.modify_s(DN_SCHEMA, mod)
+        topology_m2.ms["master1"].modify_s(DN_SCHEMA, mod)
     except ldap.LDAPError as e:
         log.fatal('Failed to add attr (%s): error (%s)' % (attr_name,
                                                            e.message['desc']))
@@ -198,7 +72,7 @@ def add_attr(topology, attr_name):
 
 
 @pytest.fixture(params=["lang-ja", "binary", "phonetic"])
-def aci_with_attr_subtype(request, topology):
+def aci_with_attr_subtype(request, topology_m2):
     """Adds and deletes an ACI in the DEFAULT_SUFFIX"""
 
     TARGET_ATTR = 'protectedOperation'
@@ -207,10 +81,10 @@ def aci_with_attr_subtype(request, topology):
 
     log.info("========Executing test with '%s' subtype========" % SUBTYPE)
     log.info("        Add a target attribute")
-    add_attr(topology, TARGET_ATTR)
+    add_attr(topology_m2, TARGET_ATTR)
 
     log.info("        Add a user attribute")
-    add_attr(topology, USER_ATTR)
+    add_attr(topology_m2, USER_ATTR)
 
     ACI_TARGET = '(targetattr=%s;%s)' % (TARGET_ATTR, SUBTYPE)
     ACI_ALLOW = '(version 3.0; acl "test aci for subtypes"; allow (read) '
@@ -220,26 +94,27 @@ def aci_with_attr_subtype(request, topology):
     log.info("        Add an ACI with attribute subtype")
     mod = [(ldap.MOD_ADD, 'aci', ACI_BODY)]
     try:
-        topology.master1.modify_s(DEFAULT_SUFFIX, mod)
+        topology_m2.ms["master1"].modify_s(DEFAULT_SUFFIX, mod)
     except ldap.LDAPError as e:
         log.fatal('Failed to add ACI: error (%s)' % (e.message['desc']))
         assert False
 
     def fin():
         log.info("        Finally, delete an ACI with the '%s' subtype" %
-                                                       SUBTYPE)
+                 SUBTYPE)
         mod = [(ldap.MOD_DELETE, 'aci', ACI_BODY)]
         try:
-            topology.master1.modify_s(DEFAULT_SUFFIX, mod)
+            topology_m2.ms["master1"].modify_s(DEFAULT_SUFFIX, mod)
         except ldap.LDAPError as e:
             log.fatal('Failed to delete ACI: error (%s)' % (e.message['desc']))
             assert False
+
     request.addfinalizer(fin)
 
     return ACI_BODY
 
 
-def test_aci_attr_subtype_targetattr(topology, aci_with_attr_subtype):
+def test_aci_attr_subtype_targetattr(topology_m2, aci_with_attr_subtype):
     """Checks, that ACIs allow attribute subtypes in the targetattr keyword
 
     Test description:
@@ -254,9 +129,9 @@ def test_aci_attr_subtype_targetattr(topology, aci_with_attr_subtype):
 
     log.info("        Search for the added attribute")
     try:
-        entries = topology.master1.search_s(DEFAULT_SUFFIX,
-                                               ldap.SCOPE_BASE,
-                                               '(objectclass=*)', ['aci'])
+        entries = topology_m2.ms["master1"].search_s(DEFAULT_SUFFIX,
+                                                     ldap.SCOPE_BASE,
+                                                     '(objectclass=*)', ['aci'])
         entry = str(entries[0])
         assert aci_with_attr_subtype in entry
         log.info("        The added attribute was found")
@@ -266,98 +141,97 @@ def test_aci_attr_subtype_targetattr(topology, aci_with_attr_subtype):
         assert False
 
 
-def _bind_manager(topology):
-    topology.master1.log.info("Bind as %s " % DN_DM)
-    topology.master1.simple_bind_s(DN_DM, PASSWORD)
+def _bind_manager(topology_m2):
+    topology_m2.ms["master1"].log.info("Bind as %s " % DN_DM)
+    topology_m2.ms["master1"].simple_bind_s(DN_DM, PASSWORD)
 
 
-def _bind_normal(topology):
+def _bind_normal(topology_m2):
     # bind as bind_entry
-    topology.master1.log.info("Bind as %s" % BIND_DN)
-    topology.master1.simple_bind_s(BIND_DN, BIND_PW)
+    topology_m2.ms["master1"].log.info("Bind as %s" % BIND_DN)
+    topology_m2.ms["master1"].simple_bind_s(BIND_DN, BIND_PW)
 
 
-def _moddn_aci_deny_tree(topology, mod_type=None,
+def _moddn_aci_deny_tree(topology_m2, mod_type=None,
                          target_from=STAGING_DN, target_to=PROD_EXCEPT_DN):
     """It denies the access moddn_to in cn=except,cn=accounts,SUFFIX"""
 
     assert mod_type is not None
 
     ACI_TARGET_FROM = ""
-    ACI_TARGET_TO   = ""
+    ACI_TARGET_TO = ""
     if target_from:
         ACI_TARGET_FROM = "(target_from = \"ldap:///%s\")" % (target_from)
     if target_to:
-        ACI_TARGET_TO   = "(target_to   = \"ldap:///%s\")" % (target_to)
+        ACI_TARGET_TO = "(target_to   = \"ldap:///%s\")" % (target_to)
 
-    ACI_ALLOW        = "(version 3.0; acl \"Deny MODDN to prod_except\"; deny (moddn)"
-    ACI_SUBJECT      = " userdn = \"ldap:///%s\";)" % BIND_DN
-    ACI_BODY         = ACI_TARGET_TO + ACI_TARGET_FROM + ACI_ALLOW + ACI_SUBJECT
+    ACI_ALLOW = "(version 3.0; acl \"Deny MODDN to prod_except\"; deny (moddn)"
+    ACI_SUBJECT = " userdn = \"ldap:///%s\";)" % BIND_DN
+    ACI_BODY = ACI_TARGET_TO + ACI_TARGET_FROM + ACI_ALLOW + ACI_SUBJECT
     mod = [(mod_type, 'aci', ACI_BODY)]
-    #topology.master1.modify_s(SUFFIX, mod)
-    topology.master1.log.info("Add a DENY aci under %s " % PROD_EXCEPT_DN)
-    topology.master1.modify_s(PROD_EXCEPT_DN, mod)
+    # topology_m2.ms["master1"].modify_s(SUFFIX, mod)
+    topology_m2.ms["master1"].log.info("Add a DENY aci under %s " % PROD_EXCEPT_DN)
+    topology_m2.ms["master1"].modify_s(PROD_EXCEPT_DN, mod)
 
 
-def _write_aci_staging(topology, mod_type=None):
+def _write_aci_staging(topology_m2, mod_type=None):
     assert mod_type is not None
 
     ACI_TARGET = "(targetattr= \"cn\")(target=\"ldap:///cn=*,%s\")" % STAGING_DN
-    ACI_ALLOW        = "(version 3.0; acl \"write staging entries\"; allow (write)"
-    ACI_SUBJECT      = " userdn = \"ldap:///%s\";)" % BIND_DN
-    ACI_BODY         = ACI_TARGET + ACI_ALLOW + ACI_SUBJECT
+    ACI_ALLOW = "(version 3.0; acl \"write staging entries\"; allow (write)"
+    ACI_SUBJECT = " userdn = \"ldap:///%s\";)" % BIND_DN
+    ACI_BODY = ACI_TARGET + ACI_ALLOW + ACI_SUBJECT
     mod = [(mod_type, 'aci', ACI_BODY)]
-    topology.master1.modify_s(SUFFIX, mod)
+    topology_m2.ms["master1"].modify_s(SUFFIX, mod)
 
 
-def _write_aci_production(topology, mod_type=None):
+def _write_aci_production(topology_m2, mod_type=None):
     assert mod_type is not None
 
     ACI_TARGET = "(targetattr= \"cn\")(target=\"ldap:///cn=*,%s\")" % PRODUCTION_DN
-    ACI_ALLOW        = "(version 3.0; acl \"write production entries\"; allow (write)"
-    ACI_SUBJECT      = " userdn = \"ldap:///%s\";)" % BIND_DN
-    ACI_BODY         = ACI_TARGET + ACI_ALLOW + ACI_SUBJECT
+    ACI_ALLOW = "(version 3.0; acl \"write production entries\"; allow (write)"
+    ACI_SUBJECT = " userdn = \"ldap:///%s\";)" % BIND_DN
+    ACI_BODY = ACI_TARGET + ACI_ALLOW + ACI_SUBJECT
     mod = [(mod_type, 'aci', ACI_BODY)]
-    topology.master1.modify_s(SUFFIX, mod)
+    topology_m2.ms["master1"].modify_s(SUFFIX, mod)
 
 
-def _moddn_aci_staging_to_production(topology, mod_type=None,
+def _moddn_aci_staging_to_production(topology_m2, mod_type=None,
                                      target_from=STAGING_DN, target_to=PRODUCTION_DN):
     assert mod_type is not None
 
-
     ACI_TARGET_FROM = ""
-    ACI_TARGET_TO   = ""
+    ACI_TARGET_TO = ""
     if target_from:
         ACI_TARGET_FROM = "(target_from = \"ldap:///%s\")" % (target_from)
     if target_to:
-        ACI_TARGET_TO   = "(target_to   = \"ldap:///%s\")" % (target_to)
+        ACI_TARGET_TO = "(target_to   = \"ldap:///%s\")" % (target_to)
 
-    ACI_ALLOW        = "(version 3.0; acl \"MODDN from staging to production\"; allow (moddn)"
-    ACI_SUBJECT      = " userdn = \"ldap:///%s\";)" % BIND_DN
-    ACI_BODY         = ACI_TARGET_FROM + ACI_TARGET_TO + ACI_ALLOW + ACI_SUBJECT
+    ACI_ALLOW = "(version 3.0; acl \"MODDN from staging to production\"; allow (moddn)"
+    ACI_SUBJECT = " userdn = \"ldap:///%s\";)" % BIND_DN
+    ACI_BODY = ACI_TARGET_FROM + ACI_TARGET_TO + ACI_ALLOW + ACI_SUBJECT
     mod = [(mod_type, 'aci', ACI_BODY)]
-    topology.master1.modify_s(SUFFIX, mod)
+    topology_m2.ms["master1"].modify_s(SUFFIX, mod)
 
-    _write_aci_staging(topology, mod_type=mod_type)
+    _write_aci_staging(topology_m2, mod_type=mod_type)
 
 
-def _moddn_aci_from_production_to_staging(topology, mod_type=None):
+def _moddn_aci_from_production_to_staging(topology_m2, mod_type=None):
     assert mod_type is not None
 
-    ACI_TARGET       = "(target_from = \"ldap:///%s\") (target_to = \"ldap:///%s\")" % (
-                        PRODUCTION_DN, STAGING_DN)
-    ACI_ALLOW        = "(version 3.0; acl \"MODDN from production to staging\"; allow (moddn)"
-    ACI_SUBJECT      = " userdn = \"ldap:///%s\";)" % BIND_DN
-    ACI_BODY         = ACI_TARGET + ACI_ALLOW + ACI_SUBJECT
+    ACI_TARGET = "(target_from = \"ldap:///%s\") (target_to = \"ldap:///%s\")" % (
+        PRODUCTION_DN, STAGING_DN)
+    ACI_ALLOW = "(version 3.0; acl \"MODDN from production to staging\"; allow (moddn)"
+    ACI_SUBJECT = " userdn = \"ldap:///%s\";)" % BIND_DN
+    ACI_BODY = ACI_TARGET + ACI_ALLOW + ACI_SUBJECT
     mod = [(mod_type, 'aci', ACI_BODY)]
-    topology.master1.modify_s(SUFFIX, mod)
+    topology_m2.ms["master1"].modify_s(SUFFIX, mod)
 
-    _write_aci_production(topology, mod_type=mod_type)
+    _write_aci_production(topology_m2, mod_type=mod_type)
 
 
 @pytest.fixture(scope="module")
-def moddn_setup(topology):
+def moddn_setup(topology_m2):
     """Creates
        - a staging DIT
        - a production DIT
@@ -365,94 +239,94 @@ def moddn_setup(topology):
        - enable ACL logging (commented for performance reason)
     """
 
-    topology.master1.log.info("\n\n######## INITIALIZATION ########\n")
+    topology_m2.ms["master1"].log.info("\n\n######## INITIALIZATION ########\n")
 
     # entry used to bind with
-    topology.master1.log.info("Add %s" % BIND_DN)
-    topology.master1.add_s(Entry((BIND_DN, {
-                                            'objectclass': "top person".split(),
-                                            'sn':           BIND_CN,
-                                            'cn':           BIND_CN,
-                                            'userpassword': BIND_PW})))
+    topology_m2.ms["master1"].log.info("Add %s" % BIND_DN)
+    topology_m2.ms["master1"].add_s(Entry((BIND_DN, {
+        'objectclass': "top person".split(),
+        'sn': BIND_CN,
+        'cn': BIND_CN,
+        'userpassword': BIND_PW})))
 
     # DIT for staging
-    topology.master1.log.info("Add %s" % STAGING_DN)
-    topology.master1.add_s(Entry((STAGING_DN, {
-                                            'objectclass': "top organizationalRole".split(),
-                                            'cn':           STAGING_CN,
-                                            'description': "staging DIT"})))
+    topology_m2.ms["master1"].log.info("Add %s" % STAGING_DN)
+    topology_m2.ms["master1"].add_s(Entry((STAGING_DN, {
+        'objectclass': "top organizationalRole".split(),
+        'cn': STAGING_CN,
+        'description': "staging DIT"})))
 
     # DIT for production
-    topology.master1.log.info("Add %s" % PRODUCTION_DN)
-    topology.master1.add_s(Entry((PRODUCTION_DN, {
-                                            'objectclass': "top organizationalRole".split(),
-                                            'cn':           PRODUCTION_CN,
-                                            'description': "production DIT"})))
+    topology_m2.ms["master1"].log.info("Add %s" % PRODUCTION_DN)
+    topology_m2.ms["master1"].add_s(Entry((PRODUCTION_DN, {
+        'objectclass': "top organizationalRole".split(),
+        'cn': PRODUCTION_CN,
+        'description': "production DIT"})))
 
     # DIT for production/except
-    topology.master1.log.info("Add %s" % PROD_EXCEPT_DN)
-    topology.master1.add_s(Entry((PROD_EXCEPT_DN, {
-                                            'objectclass': "top organizationalRole".split(),
-                                            'cn':           EXCEPT_CN,
-                                            'description': "production except DIT"})))
+    topology_m2.ms["master1"].log.info("Add %s" % PROD_EXCEPT_DN)
+    topology_m2.ms["master1"].add_s(Entry((PROD_EXCEPT_DN, {
+        'objectclass': "top organizationalRole".split(),
+        'cn': EXCEPT_CN,
+        'description': "production except DIT"})))
 
     # enable acl error logging
-    #mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', '128')]
-    #topology.master1.modify_s(DN_CONFIG, mod)
-    #topology.master2.modify_s(DN_CONFIG, mod)
+    # mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', '128')]
+    # topology_m2.ms["master1"].modify_s(DN_CONFIG, mod)
+    # topology_m2.ms["master2"].modify_s(DN_CONFIG, mod)
 
     # add dummy entries in the staging DIT
     for cpt in range(MAX_ACCOUNTS):
         name = "%s%d" % (NEW_ACCOUNT, cpt)
-        topology.master1.add_s(Entry(("cn=%s,%s" % (name, STAGING_DN), {
-                                            'objectclass': "top person".split(),
-                                            'sn': name,
-                                            'cn': name})))
+        topology_m2.ms["master1"].add_s(Entry(("cn=%s,%s" % (name, STAGING_DN), {
+            'objectclass': "top person".split(),
+            'sn': name,
+            'cn': name})))
 
 
-def test_mode_default_add_deny(topology, moddn_setup):
+def test_mode_default_add_deny(topology_m2, moddn_setup):
     """This test case checks
     that the ADD operation fails (no ADD aci on production)
     """
 
-    topology.master1.log.info("\n\n######## mode moddn_aci : ADD (should fail) ########\n")
+    topology_m2.ms["master1"].log.info("\n\n######## mode moddn_aci : ADD (should fail) ########\n")
 
-    _bind_normal(topology)
+    _bind_normal(topology_m2)
 
     #
     # First try to add an entry in production => INSUFFICIENT_ACCESS
     #
     try:
-        topology.master1.log.info("Try to add %s" % PRODUCTION_DN)
+        topology_m2.ms["master1"].log.info("Try to add %s" % PRODUCTION_DN)
         name = "%s%d" % (NEW_ACCOUNT, 0)
-        topology.master1.add_s(Entry(("cn=%s,%s" % (name, PRODUCTION_DN), {
-                                                'objectclass': "top person".split(),
-                                                'sn': name,
-                                                'cn': name})))
+        topology_m2.ms["master1"].add_s(Entry(("cn=%s,%s" % (name, PRODUCTION_DN), {
+            'objectclass': "top person".split(),
+            'sn': name,
+            'cn': name})))
         assert 0  # this is an error, we should not be allowed to add an entry in production
     except Exception as e:
-        topology.master1.log.info("Exception (expected): %s" % type(e).__name__)
+        topology_m2.ms["master1"].log.info("Exception (expected): %s" % type(e).__name__)
         assert isinstance(e, ldap.INSUFFICIENT_ACCESS)
 
 
-def test_mode_default_delete_deny(topology, moddn_setup):
+def test_mode_default_delete_deny(topology_m2, moddn_setup):
     """This test case checks
     that the DEL operation fails (no 'delete' aci on production)
     """
 
-    topology.master1.log.info("\n\n######## DELETE (should fail) ########\n")
+    topology_m2.ms["master1"].log.info("\n\n######## DELETE (should fail) ########\n")
 
-    _bind_normal(topology)
+    _bind_normal(topology_m2)
     #
     # Second try to delete an entry in staging => INSUFFICIENT_ACCESS
     #
     try:
-        topology.master1.log.info("Try to delete %s" % STAGING_DN)
+        topology_m2.ms["master1"].log.info("Try to delete %s" % STAGING_DN)
         name = "%s%d" % (NEW_ACCOUNT, 0)
-        topology.master1.delete_s("cn=%s,%s" % (name, STAGING_DN))
+        topology_m2.ms["master1"].delete_s("cn=%s,%s" % (name, STAGING_DN))
         assert 0  # this is an error, we should not be allowed to add an entry in production
     except Exception as e:
-        topology.master1.log.info("Exception (expected): %s" % type(e).__name__)
+        topology_m2.ms["master1"].log.info("Exception (expected): %s" % type(e).__name__)
         assert isinstance(e, ldap.INSUFFICIENT_ACCESS)
 
 
@@ -466,17 +340,17 @@ def test_mode_default_delete_deny(topology, moddn_setup):
                           (6, None, PRODUCTION_PATTERN, False),
                           (7, STAGING_PATTERN, None, False),
                           (8, None, None, False)])
-def test_moddn_staging_prod(topology, moddn_setup,
+def test_moddn_staging_prod(topology_m2, moddn_setup,
                             index, tfrom, tto, failure):
     """This test case MOVE entry NEW_ACCOUNT0 from staging to prod
     target_to/target_from: equality filter
     """
 
-    topology.master1.log.info("\n\n######## MOVE staging -> Prod (%s) ########\n" % index)
-    _bind_normal(topology)
+    topology_m2.ms["master1"].log.info("\n\n######## MOVE staging -> Prod (%s) ########\n" % index)
+    _bind_normal(topology_m2)
 
     old_rdn = "cn=%s%s" % (NEW_ACCOUNT, index)
-    old_dn  = "%s,%s" % (old_rdn, STAGING_DN)
+    old_dn = "%s,%s" % (old_rdn, STAGING_DN)
     new_rdn = old_rdn
     new_superior = PRODUCTION_DN
 
@@ -484,39 +358,39 @@ def test_moddn_staging_prod(topology, moddn_setup,
     # Try to rename without the apropriate ACI  => INSUFFICIENT_ACCESS
     #
     try:
-        topology.master1.log.info("Try to MODDN %s -> %s,%s" % (old_dn, new_rdn, new_superior))
-        topology.master1.rename_s(old_dn, new_rdn, newsuperior=new_superior)
+        topology_m2.ms["master1"].log.info("Try to MODDN %s -> %s,%s" % (old_dn, new_rdn, new_superior))
+        topology_m2.ms["master1"].rename_s(old_dn, new_rdn, newsuperior=new_superior)
         assert 0
     except AssertionError:
-        topology.master1.log.info("Exception (not really expected exception but that is fine as it fails to rename)")
+        topology_m2.ms["master1"].log.info(
+            "Exception (not really expected exception but that is fine as it fails to rename)")
     except Exception as e:
-        topology.master1.log.info("Exception (expected): %s" % type(e).__name__)
+        topology_m2.ms["master1"].log.info("Exception (expected): %s" % type(e).__name__)
         assert isinstance(e, ldap.INSUFFICIENT_ACCESS)
 
-
     # successfull MOD with the ACI
-    topology.master1.log.info("\n\n######## MOVE to and from equality filter ########\n")
-    _bind_manager(topology)
-    _moddn_aci_staging_to_production(topology, mod_type=ldap.MOD_ADD,
+    topology_m2.ms["master1"].log.info("\n\n######## MOVE to and from equality filter ########\n")
+    _bind_manager(topology_m2)
+    _moddn_aci_staging_to_production(topology_m2, mod_type=ldap.MOD_ADD,
                                      target_from=tfrom, target_to=tto)
-    _bind_normal(topology)
+    _bind_normal(topology_m2)
 
     try:
-        topology.master1.log.info("Try to MODDN %s -> %s,%s" % (old_dn, new_rdn, new_superior))
-        topology.master1.rename_s(old_dn, new_rdn, newsuperior=new_superior)
+        topology_m2.ms["master1"].log.info("Try to MODDN %s -> %s,%s" % (old_dn, new_rdn, new_superior))
+        topology_m2.ms["master1"].rename_s(old_dn, new_rdn, newsuperior=new_superior)
     except Exception as e:
-        topology.master1.log.info("Exception (expected): %s" % type(e).__name__)
+        topology_m2.ms["master1"].log.info("Exception (expected): %s" % type(e).__name__)
         if failure:
             assert isinstance(e, ldap.INSUFFICIENT_ACCESS)
 
     # successfull MOD with the both ACI
-    _bind_manager(topology)
-    _moddn_aci_staging_to_production(topology, mod_type=ldap.MOD_DELETE,
+    _bind_manager(topology_m2)
+    _moddn_aci_staging_to_production(topology_m2, mod_type=ldap.MOD_DELETE,
                                      target_from=tfrom, target_to=tto)
-    _bind_normal(topology)
+    _bind_normal(topology_m2)
 
 
-def test_moddn_staging_prod_9(topology, moddn_setup):
+def test_moddn_staging_prod_9(topology_m2, moddn_setup):
     """This test case disable the 'moddn' right so a MODDN requires a 'add' right
     to be successfull.
     It fails to MOVE entry NEW_ACCOUNT9 from staging to prod.
@@ -529,11 +403,11 @@ def test_moddn_staging_prod_9(topology, moddn_setup):
     Then it succeeds to MOVE NEW_ACCOUNT10 from staging to prod.
     """
 
-    topology.master1.log.info("\n\n######## MOVE staging -> Prod (9) ########\n")
+    topology_m2.ms["master1"].log.info("\n\n######## MOVE staging -> Prod (9) ########\n")
 
-    _bind_normal(topology)
+    _bind_normal(topology_m2)
     old_rdn = "cn=%s9" % NEW_ACCOUNT
-    old_dn  = "%s,%s" % (old_rdn, STAGING_DN)
+    old_dn = "%s,%s" % (old_rdn, STAGING_DN)
     new_rdn = old_rdn
     new_superior = PRODUCTION_DN
 
